CREATE DATABASE FlaskMVC
GO

USE [FlaskMVC]
GO


--DROP TABLE SALESDATA
CREATE TABLE SalesData
(
Id int Identity(1,1),
SaleDate Date,
SalesAmount Decimal(10,2),
ProductName VARCHAR(50)
)

GO
--7/1/2010 - 7/1/2020
-- 12 * 10 = 120 + 7 = 127 MONTHS
IF OBJECT_ID('TEMPDB..#TEMP_PRODUCTS') IS NOT NULL DROP TABLE #TEMP_PRODUCTS
CREATE TABLE #TEMP_PRODUCTS
(
ProductName VARCHAR(50)
)

INSERT INTO #TEMP_PRODUCTS
SELECT 'Product A'
UNION
SELECT 'Product B'
UNION
SELECT 'Product C'
UNION
SELECT 'Product D'

GO

DECLARE @PRODUCTNAME VARCHAR(50)
WHILE EXISTS(SELECT TOP 1 * FROM #TEMP_PRODUCTS)
BEGIN
	SET @PRODUCTNAME = (SELECT TOP 1 PRODUCTNAME FROM #TEMP_PRODUCTS)
	DECLARE @I INT = 1, @SALESAMOUNT DECIMAL(10,2),@SALESDATE DATE = '1/1/2010'
	WHILE @I <= 127
	BEGIN
	
		SET @SALESAMOUNT = (SELECT FLOOR(RAND()*1001)) -- RANDOM AMT BETWEEN 1 - 1000

		INSERT INTO SalesData
		VALUES(@SALESDATE,@SALESAMOUNT,@PRODUCTNAME)
		SET @I = @I + 1

		SET @SALESDATE = DATEADD(MONTH,1,@SALESDATE)

	END
	DELETE FROM #TEMP_PRODUCTS WHERE ProductName = @PRODUCTNAME
END

SELECT YEAR(SALEDATE) AS [Year],SUM(SALESAMOUNT) AS SalesAmount,ProductName FROM SalesData GROUP BY YEAR(SALEDATE),ProductName ORDER BY PRODUCTNAME,[YEAR]


GO
CREATE PROC SPX_RESET_SALES_DATA

AS

TRUNCATE TABLE SALESDATA

IF OBJECT_ID('TEMPDB..#TEMP_PRODUCTS') IS NOT NULL DROP TABLE #TEMP_PRODUCTS
CREATE TABLE #TEMP_PRODUCTS
(
ProductName VARCHAR(50)
)

INSERT INTO #TEMP_PRODUCTS
SELECT 'Product A'
UNION
SELECT 'Product B'
UNION
SELECT 'Product C'
UNION
SELECT 'Product D'

DECLARE @PRODUCTNAME VARCHAR(50)
WHILE EXISTS(SELECT TOP 1 * FROM #TEMP_PRODUCTS)
BEGIN
	SET @PRODUCTNAME = (SELECT TOP 1 PRODUCTNAME FROM #TEMP_PRODUCTS)
	DECLARE @I INT = 1, @SALESAMOUNT DECIMAL(10,2),@SALESDATE DATE = '1/1/2010'
	WHILE @I <= 127
	BEGIN
	
		SET @SALESAMOUNT = (SELECT FLOOR(RAND()*1001)) -- RANDOM AMT BETWEEN 1 - 1000

		INSERT INTO SalesData
		VALUES(@SALESDATE,@SALESAMOUNT,@PRODUCTNAME)
		SET @I = @I + 1

		SET @SALESDATE = DATEADD(MONTH,1,@SALESDATE)

	END
	DELETE FROM #TEMP_PRODUCTS WHERE ProductName = @PRODUCTNAME
END


--EXEC SPX_RESET_SALES_DATA